#!/usr/bin/perl
###############################################################################
#    Backup System - Lib
#
#    Backup System Webmin Module ver. 1.01 Stable Edtion
#    Copyright (C) 2000 by Steindl Heiko
#    Bug reports to: heiko@cyberman.at
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
###############################################################################
use CGI qw(:standard param);
do '../web-lib.pl';
require "../cron/cron-lib.pl";
&init_config();
$ver = "1.01";
###############################################################################
sub start { 
###############################################################################
  &header($text{'backup_title'}, undef);
  print "<hr>\n";
  print "<table border width=100%>\n";
  print "<tr $tb> <td><b>$text{'backup_title'}</b></td></tr>\n";
  print startform qw(POST backup.cgi);
  print "<tr $cb> <td>";
 # print radio_group(prog, \@prog, prog, 'true', \%prog);
  print "<br>";
  print checkbox(gzip, undef, gzip, " $text{'backup_gzip'}");
  print "<br>";
  print checkbox(update, undef, update, " $text{'backup_update'}");
  print "<br>";
  print "<input type=radio name=restore value=backup checked> ", $text{'backup_backup'}, "<br>";
  print "<input type=radio name=restore value=restore> ", $text{'backup_restore'}, "<br>";
  print "<br>";
  print '<a href="autobackup.cgi">', $text{'backup_auto'}, '</a><br>';
  print "$text{'backup_directory'}: ";
  print textfield qw(backup_dir);
  print &file_chooser_button("backup_dir", 1, 0); print "<br>\n";
  print "$text{'backup_file'}: ";
  print textfield qw(make_backup);
  print &file_chooser_button("make_backup", 0, 0); print "<br><br>\n";
  print "<input type=submit name=Ok value=", $text{'backup_ok'}, ">";
  print "&nbsp &nbsp";
  print "<input type=reset name=Clear value=", $text{'backup_clear'}, ">";
  print "</td></tr></table>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("/", $text{'index'});
}
###############################################################################
sub check_prog {  # check if tar or cpio to use
###############################################################################
# $prog = param("prog");
  $prog = "tar";
  if ($prog eq "tar") {
    goto &exec_backup_tar;
  }
  else {
    goto &exec_backup_cpio;
  }
}
###############################################################################
sub exec_backup_tar {  # exec the backup with tar
###############################################################################
  my $backup_dir = param("backup_dir");
  my $make_backup = param("make_backup");
  $update = param("update");
  $gzip = param("gzip");
  $restore = param("restore");
  if ($gzip eq "gzip"){
    goto &exec_backup_tar_gz;
  }
  if ($restore eq "restore") {
    goto &exec_restore; 
  }
  if ($update eq "update") {
    system("tar kuip $backup_dir/ -f $make_backup");
  }
  elsif (-e "$make_backup"){
    &error(&text('backup_fexist', $make_backup));
  }
  system("tar cip $backup_dir/ -f $make_backup");
  &header($text{'backup_bdone'}, undef);
  print "<hr>\n"; 
  print "<h3>" &text('backup_bpathdone', $backup_dir, $make_backup), "</h3>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
###############################################################################
sub exec_backup_tar_gz {
###############################################################################
  my $backup_dir = param("backup_dir");
  my $make_backup = param("make_backup");
  $update = param("update");
  if ($update eq "update") {
    system("tar kuipz $backup_dir/ -f $make_backup");
  }
  elsif (-e "$make_backup.gz") {
    &error(&text('backup_fexist', $make_backup.gz));
  }
  system("tar cipz $backup_dir/ -f $make_backup");
  &header($text{'backup_bdone'}, undef);
  print "<hr>\n"; 
  print "<h3>", &text('backup_bpathdone', $backup_dir, $make_backup), "</h3>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
###############################################################################
sub exec_backup_cpio { #exec backup with cpio
###############################################################################
  my $backup_dir = param("backup_dir");
  my $make_backup = param("make_backup");
  $update = param("update");
  $restore = param("restore");
  if ($restore eq "restore") {
    goto &exec_restore; 
  }
  if ($update eq "update") {
    system("tar kuz $backup_dir/ -f $make_backup");
  }
  elsif (-e "$make_backup.gz") {
    &error(&text('backup_fexist', $make_backup.gz));
  }
  system("tar cz $backup_dir/ -f $make_backup");
  
  &header($text{'backup_bdone'}, undef);
  print "<hr>\n"; 
  print "<h3>", &text('backup_bpathdone', $backup_dir, $make_backup), "</h3>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
###############################################################################
sub exec_restore {
###############################################################################
  my $restore_dir = param("backup_dir");
  my $do_restore = param("make_backup");
  &header($text{'backup_restore'}, undef);
  print "<hr>\n";
  system("tar xvfz $do_restore -C $restore_dir 1> /dev/null");
  print "<h3>", &text('backup_rdone', $do_restore, $restore_dir), "</h3>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
###############################################################################
sub autobackup {
###############################################################################
  my $cron = param("cron");
  my $auto = param("autobackup");
  &header($text{'backup_autotitle'}, undef);
  print "<hr>\n";
  print "<table border width=100%>\n";
  print "<tr $tb> <td><b>", $text{'backup_autotitle'}, "</b></td></tr>\n";
  print "<tr $cb> <td>";
  print startform qw(POST exec_auto.cgi); 
  print "$text{'backup_autodir'}: ";
  print textfield qw(auto_backup_dir);
  print &file_chooser_button("auto_backup_dir", 1, 0); print "<br>\n";
  print "$text{'backup_autofile'}: ";
  print textfield qw(make_auto_backup);
  print &file_chooser_button("make_auto_backup", 0, 0); print "<br>\n";
  print "<input type=radio name=act value=activate checked> ", $text{'backup_activate'}, "<br>";
  print "<input type=radio name=act value=deactivate> ", $text{'backup_deactivate'}, "<br>";
  print "<br><br>";
  print "<select name=cron>\n";
  print "<option value=daily> ", $text{'backup_daily'}, "\n";
  print "<option value=hourly> ", $text{'backup_hourly'}, "\n";
  print "<option value=weekly> ", $text{'backup_weekly'}, "\n";
  print "<option value=monthly> ", $text{'backup_monthly'}, "\n";
  print "</select><br><br>\n";
  print "<input type=submit name=Ok value=", $text{'backup_ok'}, ">";
  print "&nbsp &nbsp";
  print "<input type=reset name=Clear value=", $text{'backup_clear'}, ">";
  print "</td></tr></table>";
  print "<hr>\n";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
###############################################################################
sub exec_auto {
###############################################################################
  my $auto_backup_dir = param("auto_backup_dir");
  my $make_auto_backup = param("make_auto_backup");
  my $cron = param("cron");
  my $auto = param("autobackup");
  $act = param("act");
  &header($text{'backup_autotitle'}, undef);
  if ($act eq "activate"){
    open(TMP,">backup.tmp");
    print TMP "tar cipz $auto_backup_dir/ -f $make_auto_backup";
    system("cp backup.pl /etc/cron.$cron/");
    close(TMP);
    system("mv backup.tmp /etc/cron.$cron/");
    print "<h3>", &text('backup_aactiv', $auto_backup_dir, $make_auto_backup, $cron), "</h3>";
  }
  else {
    system("rm /etc/cron.$cron/backup.pl");
    system("rm /etc/cron.$cron/backup.tmp");
    print "<h3>", &text('backup_adeact', $cron), "</h3>";
  }
  
  print "<br><hr>";
  print "<h4>", &text('backup_version', $ver), "</h4>";
  print "<hr>\n";
  &footer("", $text{'backup_return'});
}
#sub cron {
#  &header("Cron", undef);
#  print '<a href="../cron/edit_cron.cgi?new=1">cronadd</a>';
#  &footer("", $text{'index_return'});
#}
###############################################################################
return 1;
###############################################################################
#                                    EOF                                      #
###############################################################################
