#!/usr/bin/perl
###############################################################################
#    CD Backup - burn.pl
#
#    CD Backup for Webmin Module ver. 1.0
#    Copyright (C) 2000 by The Pretender <Sebastien J. Gross>
#    Bug reports to: seb@sjgross.com
#    Download:
#     http://www.freealter.com
#     http://www.sjgross.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#
###############################################################################

use CGI qw(:standard param);
do '../web-lib.pl';
require "../cron/cron-lib.pl";
&init_config();

#
# autoackup routine
#
sub exec_burn
{
  my $burner_soft = param("burner_soft");
  my $burner_speed = param("burner_speed");
  my $burner_eject = param("eject");
  my $burner_dummy = param("dummy");
  my $burner_dev = param("burner_dev");
  my $burner_blank = param("blank");
  my $burner_blank_fast = param("fast_blank");
  my $burner_iso = param("burner_iso");

  &header($text{'burning'}, undef);

  if ($burner_eject)
  {
    $eject = " -eject ";
  }

  if ($burner_dummy)
  {
    $dummy = " -dummy ";
  }

  if ($burner_blank)
  {
    if ($burner_blank_fast == "total")
    {
      $blank = " -blank=all ";
    }
    else
    {
      $blank = " -blank=fast ";
    }

    print "<h3>$text{'blank_in_progress'}</h3>\n";
    open (FILE, "$burner_soft $blank dev=$burner_dev $burner_iso | ") or die "$text('$error', $burner_soft)";
    while (<FILE>)
    {
      print "$_<br>\n";
    }
    close FILE;

    print "<h3>$text{'blank_done'}</h3>";

  }
  else
  {  
    #print "$burner_soft -v $eject speed=$burner_speed dev=$burner_dev $burner_iso<br>\n";

    print "<h3>$text{'burn_in_progress'}</h3>\n";

    open (FILE, "$burner_soft $dummy -v $eject speed=$burner_speed dev=$burner_dev $burner_iso | ") or die "$text('$error', $burner_soft)";
    while (<FILE>)
    {
      print "$_<br>\n";
    }
    close FILE;

    print "<h3>$text{'burn_done'}</h3>";

  }

  print "$text{'main_title'} $text{'version'}<br>\n";
  print "<a href=\"mailto:$text{'author_mail'}\">Sbastien J. Gross</a> - <a href=\"http://$text{'author_site'}\">$text{'author_site'}</a> --- <a href=\"http://$text{'company_site'}\">$text{'company'}</a><br>\n";
  &footer("", $text{'return_main'});

  return 1;
}
