#!/usr/bin/perl
# edit_user.cgi
# Display a form for editing a user, or creating a new user

require './user-lib.pl';
&ReadParse();
$n = $in{'num'};
$uid_passed = $in{'uid'};

#LDAP Headers
use Getopt::Std;			# To parse command line arguments.
use Mozilla::LDAP::Conn;		# Main "OO" layer for LDAP
use Mozilla::LDAP::Utils;		# LULU, utilities.
	
use strict;
no strict "vars";

$serverLDAP = "127.0.0.1";
$portLDAP = "389";
$base = "o=ServerName, c=com";

%access = &get_module_acl();

if ($n eq "") {
	$access{'ucreate'} || &error("You cannot create new users");
	&header("Create User", "images/create_user.gif", "create_user");
	}
else {
	@ulist = &list_users();
	%uinfo = %{$ulist[$n]};
	&can_edit_user(\%access, \%uinfo) ||
		&error("You cannot edit this user");
	&header("Edit User", "images/edit_user.gif", "edit_user");

	$conn = new Mozilla::LDAP::Conn($serverLDAP, $portLDAP, "cn=Manager, o=ServerName, c=com", "secret");
	die "Could't connect to LDAP server \"127.0.0.1\"" unless $conn;

    	$entry = $conn->search($base, "subtree", "(uid=$uid_passed)");
	if (! $entry)
 	{ # handle this event, no entries found, dude!
	 print "<TR><TD>Search result is empty</TD></TR>";
	} else  {
	 $cn = $entry->{cn}[0];
	 $mail = $entry->{mail}[0];
	 $o = $entry->{o}[0];
	 $title = $entry->{title}[0];
	 $giveName = $entry->{giveName}[0];
	 $sn = $entry->{sn}[0];
	 $HomeCellular = $entry->{HomeCellular}[0];
	 $streetAddress = $entry->{streetAddress}[0];
	 $st = $entry->{st}[0];
	 $postalCode = $entry->{postalCode}[0];
	 $department = $entry->{department}[0];
	 $officelocation = $entry->{officelocation}[0];
	 $telephoneNumber = $entry->{telephoneNumber}[0];
	 $officeFax = $entry->{officeFax}[0];
	 $officewebpage = $entry->{officewebpage}[0];
	 $description = $entry->{description}[0];

	 $conn->close if $conn;

       }
	
}

# Display (Modify Entry) or (New Entry)
if (! ($uid_passed eq "")) {
  $Type  = "(Modify Entry)";
  $conn = new Mozilla::LDAP::Conn($serverLDAP, $portLDAP, "cn=Manager, o=ServerName, c=com", "secret");
  die "Could't connect to LDAP server \"127.0.0.1\"" unless $conn;

  $entry = $conn->search($base, "subtree", "(uid=$uid_passed)");

  if ($entry) {

   # if Entry is found assign values to variables
   $cn = $entry->{cn}[0];
   $mail = $entry->{mail}[0];
   $o = $entry->{o}[0];
   $title = $entry->{title}[0];
   $giveName = $entry->{giveName}[0];
   $sn = $entry->{sn}[0];
   $HomeCellular = $entry->{HomeCellular}[0];
   $streetAddress = $entry->{streetAddress}[0];
   $st = $entry->{st}[0];
   $postalCode = $entry->{postalCode}[0];
   $department = $entry->{department}[0];
   $officelocation = $entry->{officelocation}[0];
   $telephoneNumber = $entry->{telephoneNumber}[0];
   $officeFax = $entry->{officeFax}[0];
   $officewebpage = $entry->{officewebpage}[0];
   $description = $entry->{description}[0];
  }

  $conn->close if $conn;
 } else {
  $Type  = "(New Entry)";
}

print "
<form action=\"save_entry.cgi\">
<table border width=100%>
<tr $tb>
  <td>
   <b>LDAP Entry $Type</b>
  </td>
 </tr>
 <tr $cb>
  <td>
   <table>
 <tr>
  <td  with=30%>
   Common Name :
  </td>
  <td  with=70%>
   <input type=text maxlen=40 value=\"$cn\" name=\"cn\">
   <input type=hidden value=\"$uid_passed\" name=\"uid\">
   <input type=hidden value=\"$cn\" name=\"cn_old\">
  </td>
 </tr>
 <tr>
  <td>
   mail :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$mail\" name=\"mail\">
  </td>
 </tr>
 <tr>
  <td>
   Company :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$o\" name=\"o\">
  </td>
 </tr>
 <tr>
  <td>
   Title :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$title\" name=\"title\">
  </td>
 </tr>
 <tr>
  <td>
   givenName :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$giveName\" name=\"giveName\">
  </td>
 </tr>
 <tr>
  <td>
   Surname :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$sn\" name=\"sn\">
  </td>
 </tr>
 <tr>
  <td>
   Cellular :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$HomeCellular\" name=\"HomeCellular\">
  </td>
 </tr>
 <tr>
  <td>
   Street Address :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$streetAddress\" name=\"streetAddress\">
  </td>
 </tr>
 <tr>
  <td>
   Work State :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$st\" name=\"st\">
  </td>
 </tr>
 <tr>
  <td>
   Postal Code :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$postalCode\" name=\"postalCode\">
  </td>
 </tr>
 <tr>
  <td>
   Work Department :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$department\" name=\"department\">
  </td>
 </tr>
 <tr>
  <td>
   Office Location :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$officelocation\" name=\"officelocation\">
  </td>
 </tr>
 <tr>
  <td>
   Telephone Number :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$telephoneNumber\" name=\"telephoneNumber\">
  </td>
 </tr>
 <tr>
  <td>
   Office Fax :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$officeFax\" name=\"officeFax\">
  </td>
 </tr>
 <tr>
  <td>
   Office Webpage :
  </td>
  <td>
   <input type=text maxlen=40 value=\"$officewebpage\" name=\"officewebpage\">
  </td>
 </tr>
 <tr>
  <td>
   Description (Notes) :
  </td>
  <td>
   <TEXTAREA NAME=\"description\">$description</TEXTAREA>
  </td>
 </tr>
</table>
</TD>
</tr>
</table>
";

print "<table width=100%>\n";
print " <TR>\n";
print "  <TD>\n";
print "   <input type=submit value=\"Save\"></form>";
print "  </TD>\n";
print "  <TD>\n";
print "   <form action=\"index.cgi\"><input type=submit value=\"Show Entries\"></form>";
print "  </TD>\n";
print "  <TD>\n";
print "   <form action=\"delete_entry.cgi\"><input type=submit value=\"Delete\"><input type=hidden value=\"$uid_passed\" name=uid><input type=hidden value=\"$cn\" name=cn></form>";
print "  </TD>\n";
print " </TR>\n";
print "</table>\n";

print "<hr>\n";
&footer("", "user and groups list");