#!/bin/bash

# (gc) security fix: we test if we are in install
[ -z "$DURING_INSTALL" ] || exit 0

echo "In webmin post install..."

if [ -d /etc/webmin ]
then
  upgrade_webmin=1
  cp -f /etc/webmin/miniserv.users /root/tmp/webmin.miniserv.users.$$
  cp -f /etc/webmin/webmin.acl /root/tmp/webmin.webmin.acl.$$
  rm -rf /etc/webmin
fi

cd /usr/share/webmin
config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=1
port=10000
login=root
if [ -r /etc/shadow ]; then
	crypt=`grep "^root:" /etc/shadow | cut -f 2 -d :`
else
	crypt=`grep "^root:" /etc/passwd | cut -f 2 -d :`
fi
host=`hostname`
ssl=1
atboot=0
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow
[ -z "$SECURE_LEVEL" ] && export SECURE_LEVEL=3
if [ -f /etc/issue ]; then /bin/true; else
  if [ -f /etc/mandrake-release ]; then cp /etc/mandrake-release /etc/issue; else
    cat << FIN > /etc/issue
Mandrake release 7.2
FIN
  fi
fi
mkdir -p /var/log/webmin
./setup.sh > /var/log/webmin/webmin_install.log 2> /var/log/webmin/webmin_install.log.err < /dev/null

if [ "$upgrade_webmin" = "1" ]
then
  cp -f /root/tmp/webmin.miniserv.users.$$ /etc/webmin/miniserv.users
  cp -f /root/tmp/webmin.webmin.acl.$$ /etc/webmin/webmin.acl
  rm -f /root/tmp/webmin.*
  ./setup.sh > /var/log/webmin/webmin_upgrade.log 2> /var/log/webmin/webmin_upgrade.log.err < /dev/null
fi
