#!/usr/bin/perl

require '../web-lib.pl';

&init_config("qmail");


sub check_qmail_running() {
    
    $running_pid="";
    $running_pid=`ps auOP|awk $5 ~ /^qmail-send/ { print $1 } `;	
    if ($running_pid eq "") {
	return(0);
    } else {
	return ($running_pid);
    }
}



sub get_virtual_domains() {
    local($virtfile)=$config{'qmail_dir'}."/".$config{'qmail_virthost'};
    local(@virtdomain);
    open(VIRT,"< $virtfile")||&error("File Not Found $virtfile");						 
    while (<VIRT>) {
	if ($_ =~ /^(\S+):(\S+)$/) {
	    push(@virtdomain,$1);
	}
    }
    close(VIRT);
    return(@virtdomain);
}

sub get_virtual_domain_user() {
    local($d)=@_;
    local($virtfile)=$config{'qmail_dir'} . "/" . $config{'qmail_virthost'};
    open (VIRT,"< $virtfile")||&error("File not found $virtfile");
    while (<VIRT>) {
	if ($_ =~ /^$d:(\S+)/) {
	    return ($1);
	}
    }
    close(VIRT);
    return("");
}

sub get_email_addr() {
    local($u)=@_;
    local(@eaddr);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($u);
    opendir(DIR,"$dir");
    $direc=readdir(DIR);
    while ($direc ne "") {
	if ($direc =~ /^.qmail/) {
	    if ($direc=~/^.qmail-(\S+)/) {
		if ($1 ne "default") {
		    push(@eaddr,$1);
		}
	    } else {
		if ($#eaddr==-1) {
		    push(@eaddr,"This is a domain pop3-account");
		}
	    }
	}
	$direc=readdir(DIR);
    }
    closedir(DIR);
    return(sort(@eaddr));
}

sub get_email_addr2() {
    local($u)=@_;
    local(@eaddr);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($u);
    opendir(DIR,"$dir");
    $direc=readdir(DIR);
    while ($direc ne "") {
	if ($direc=~/^.qmail/) {
	    if ($direc=~/^.qmail-(\S+)/) {
		if ($1 ne "default") {
		    push(@eaddr,$1);
		}
	    }
	}
	$direc=readdir(DIR);
    }
    closedir(DIR);
    return(sort(@eaddr));
}


sub get_user_list() {    
    local(@userlist);
    local($user);
    ($user)=split(/:/,getpwent());
    while ($user ne "") {
	push(@userlist,$user);
	($user)=split(/:/,getpwent());
    }
    endpwent();
    return(@userlist);
}

sub create_virtual_domain() {
    local($domain,$user)=@_;
    local($virthost)=$config{'qmail_dir'} . "/". $config{'qmail_virthost'};
    local ($rcpthost)=$config{'qmail_dir'} . "/". $config{'qmail_rcpthost'};
    local($gefunden);

    $domain=~/^[A-z0-9\-\.]+$/ || &error("$domain is not a valid domain name");
    &check_ipaddress($domain) && &error("$domain is an IP Address, not a domainname");
    open(RCPT,"< $rcpthost")||&error("File not found $rcpthost");
    while (<RCPT>) {
	chomp($_);
	chomp($domain);
	if (lc($_) eq lc($domain)) {
	    $gefunden=1;
	    last;
	} else {
	    $gefunden=0;
	}
    }
    close(RCPT);
    if ($gefunden==0) {
	open(RCPT,">> $rcpthost")||&error("File not found $rcpthost");
	print RCPT "$domain\n";
	close(RCPT);
    }
    open(VIRT,"< $virthost")||&error("File not found $virthost");
    while(<VIRT>) {
	if ($_ =~ /^(\S+):/ && lc($1) eq lc($domain)) {
	    $gefunden=1;
	    last;
	} else {
	    $gefunden=0;
	}
    }
    close(VIRT);
    if ($gefunden==1) {
	&error("$domain is already in $virthost");
	return(1);
    } else {
	open(VIRT,">> $virthost")||&error("File not found $virthost");
	print VIRT "$domain:$user\n";
	close(VIRT);
	return(0);
    }
}


sub get_number_of_emails() {
    local($u,$e)=@_;
    local($realuser);
    if ($e !~ /^This is/) {
	($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($u);
	chomp($e);
	open(REALUSER,"< $dir/.qmail-$e")||&error("File not found");
	while (<REALUSER>) { $realuser=$_; } 
	close(REALUSER);
    } else {
	$realuser=$u;
    }
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($realuser);
    $anzahl=`ls $dir/Maildir/new|wc -l`;
    return($anzahl);
}

sub get_kb_of_email() {
    local($u,$e)=@_;
    local($realuser);
    if ($e !~ /^This is/) {
	($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($u);
	chomp($e);
	open(REALUSER,"< $dir/.qmail-$e")||&error("File not found");
	while (<REALUSER>) { $realuser=$_; } 
	close(REALUSER);
    } else {
	$realuser=$u;
    }
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($realuser);
    $byte=`du -bc $dir/Maildir/new/|grep "total"`;
    ($byte,$tt)=split(/\t/,$byte);
    return($byte);
}

sub read_email() {
    local($em)=@_;
    local(@e);
    open(MAIL,"< $em")|| &error("File not found $em");
    while (<MAIL>) {
	push(@e,$_);
    }
    close(MAIL);
    return(@e);
}

sub get_email_list() {
    local($virtdom,$user)=@_;
    local(@emaillist);
    local($realuser);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($virtdom);
    if ($user !~ /^This is/) {
	open(QMAILFILE,"< $dir/.qmail-$user")|| &error("File not Found !");
    } else {
	open(QMAILFILE,"< $dir/.qmail")|| &error("File not found !");
    }	
    while (<QMAILFILE>) {
	$realuser=$_;
    }
    close(QMAILFILE);
    if ($user !~ /^This is/) {
	($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($realuser);
	opendir(DIR,"$dir/Maildir/new/");
    } else {
	opendir(DIR,"$dir/Maildir/new/");
    }
    $direc=readdir(DIR);
    while ($direc ne "") {
	if ($direc !~/^\./) {
	    push(@emaillist,"$dir/Maildir/new/$direc");
	}
	$direc=readdir(DIR);
    }
    closedir(DIR);
    return(@emaillist);
}

sub delete_email() {
    local($email)=@_;
    unlink($email);
    return(1);
}

sub create_email_address() {
    local($username,$user,$virtualdomain)=@_;
    $virtdomuser=&get_virtual_domain_user($virtualdomain);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($virtdomuser);
    open(QMAILFILE,"> $dir/.qmail-$username");
    print QMAILFILE "$user";
    close(QMAILFILE);
    chown($uid,$gid,"$dir/.qmail-$username");
}

sub delete_email_address() {
    local($username,$virtualdomain)=@_;    
    $virtdomuser=&get_virtual_domain_user($virtualdomain);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($virtdomuser);
    if (-f "$dir/.qmail-$username") {
	unlink ("$dir/.qmail-$username");
    }
}

sub delete_virtual_domain() {
    local($domain)=@_;
    $virtdomuser=&get_virtual_domain_user($domain);
    ($name,$passwd,$uid,$gid,$quota,$comment,$gcos,$dir,$shell)=getpwnam($virtdomuser);
    $virtdomfile=$config{'qmail_dir'}."/".$config{'qmail_virthost'};
    $rcpthostfile=$config{'qmail_dir'}."/".$config{'qmail_rcpthost'};
    open(RCPTHOST,"< $rcpthostfile")||&error("cant open $rcpthostfile");
    $tmpfilename=&tempname();
    open(RCPTNEW,"> $tmpfilename");
    while (<RCPTHOST>) {
	chomp;
	if (lc($_) ne lc($domain)) {
	    print RCPTNEW "$_\n";
	}
    }
    close(RCPTHOST);
    close(RCPTNEW);
    system("cp $tmpfilename $rcpthostfile");
    unlink($tmpfilename);
    open(VIRTHOST,"< $virtdomfile")||&error("cant open $virtdomfile");
    open(VIRTNEW,"> $tmpfilename");
    while (<VIRTHOST>) {
	if ($_=~ /^(\S+):/ && $1 ne $domain) {
	    print VIRTNEW "$_";
	}
    }
    close(VIRTHOST);
    close(VIRTNEW);
    system("cp $tmpfilename $virtdomfile");
    unlink($tmpfilename);

}

sub get_rcpt_hosts() {
    local(@rcpthosts);
    $rcpthostfile=$config{'qmail_dir'}."/".$config{'qmail_rcpthost'};
    open(RCPTHOST,"< $rcpthostfile")||&error("Cant find $rcpthostfile");
    while (<RCPTHOST>) {
	chomp;
	push(@rcpthosts,$_);
    }
    close(RCPTHOST);
    return(sort(@rcpthosts));
}

sub add_rcpt_hosts() {
    local($domain)=@_;
    local($gefunden);
    $rcpthostfile=$config{'qmail_dir'}."/".$config{'qmail_rcpthost'};
    open(RCPTHOST,"< $rcpthostfile")||&error("Cant find $rcpthostfile");
    while (<RCPTHOST>) {
	chomp;
	if ($_ ne $domain) {
	    $gefunden=0;
	} else {
	    $gefunden=1;
	    last;
	}
    }
    close(RCPTHOST);
    if ($gefunden==0) {
	open(RCPTHOST,">> $rcpthostfile");
	print RCPTHOST "$domain\n";
	close(RCPTHOST);
	return(0);
    } else {
	return(1);
    }
}

sub del_rcpt_hosts() {
    local($domain)=@_;
    $rcpthostfile=$config{'qmail_dir'}."/".$config{'qmail_rcpthost'};
    open(RCPTHOST,"< $rcpthostfile")||&error("Cant find $rcpthostfile");
    $tmpfile=&tempname();
    open(RCPTNEW,"> $tmpfile");
    while (<RCPTHOST>) {
	chomp;
	if ($domain ne $_) {
	    print RCPTNEW "$_\n";
	}
    }
    close(RCPTHOST);
    close(RCPTNEW);
    system("cp $tmpfile $rcpthostfile");
    return (0);
}


sub get_locals() {
    local(@locals);
    $localsfile=$config{'qmail_dir'}."/".$config{'qmail_locals'};
    open(LOCALS,"< $localsfile")||&error("Cant find $localsfile");
    while (<LOCALS>) {
	chomp;
	push(@locals,$_);
    }
    close(LOCALS);
    return(sort(@locals));
}

sub add_locals() {
    local($domain)=@_;
    local($gefunden);
    $localsfile=$config{'qmail_dir'}."/".$config{'qmail_locals'};
    open(LOCALS,"< $localsfile")||&error("Cant find $localsfile");
    while (<LOCALS>) {
	chomp;
	if ($_ ne $domain) {
	    $gefunden=0;
	} else {
	    $gefunden=1;
	    last;
	}
    }
    close(LOCALS);
    if ($gefunden==0) {
	open(LOCALS,">> $localsfile");
	print LOCALS "$domain\n";
	close(LOCALS);
	return(0);
    } else {
	return(1);
    }
}

sub del_locals() {
    local($domain)=@_;
    $localsfile=$config{'qmail_dir'}."/".$config{'qmail_locals'};
    open(LOCALS,"< $localsfile")||&error("Cant find $localsfile");
    $tmpfile=&tempname();
    open(LOCALNEW,"> $tmpfile");
    while (<LOCALS>) {
	chomp;
	if ($domain ne $_) {
	    print LOCALNEW "$_\n";
	}
    }
    close(LOCALS);
    close(LOCALNEW);
    system("cp $tmpfile $localsfile");
    return (0);
}



