#!/usr/bin/perl
###################################################################
# Vacation Webmin module written by Chris Brennan                 #
###################################################################
#                                                                 #
# $Id: vacation.cgi,v 1.3 2000/09/08 13:07:47 devil Exp $
#                                                                 #
###################################################################
#                                                                 #
# Module allows for admins and users to alter their .forward with #
# authentication through FTP.  This module is given freely, with  #
# no responsibility for its use or upkeep to be placed on the     #
# author. I am, of course interested in ideas on improving things #
# so email: devil@research.at                                     #
#                                                                 #
###################################################################
#                                                                 #
# vacation.cgi                                                    #
#    This script receives input from the index.cgi HTML form.     #
#    If the form input 'mode' has a value of 'unset', then the    #
#    script FTPs to the server housing the user with their login  #
#    information and deletes the vacation related files.          #
#    If 'mode'=set, then the appropiate files are first created   #
#    as temp files in /tmp and then FTPed to the user directory.  #
#    NOTE:  You need to have libnet to use Net::FTP               #
#                                                                 #
###################################################################

do '../web-lib.pl';

use Net::FTP;

&init_config();

umask(077);				# be secretive about files

$tmp="/tmp/list.$$";			# a temp file

# We use Post/Get Method to send some variables

&ReadParse();

$mess=	   $in{'mess'};		# vacation message
$user=     $in{'user'};		# your login name
$pass=     $in{'pass'};		# your login password
$mode=     $in{'mode'};		# set/or unset

# Pretty much all pages begin this way

sub html_open {
&header("Vacation Mail Results", "");  
}

# All pages are closed this way

sub html_close {
    &footer("index.cgi", "Vacation Admin");
    unlink($tmp);
    exit;
}

# Oops preverse situation -- die cleanly closing off the html

sub html_abort {
    &html_open();
    print "<HR>\n";
    print "<STRONG>Error:</STRONG> @_\n";
    print "<P>\n";
    print "Use the link below, or your <b>back</b> function to navigate back to where you were.\n";
    &html_close();
}

# To unset vacation service connect and remove all files created

sub unset_vacation {
    $ftp = Net::FTP->new($config{'server_domain'}, Debug => 0);
 
    unless ($ftp->login($user, $pass)) {
        $ftp->quit;
        &html_abort("Cannot log into server!  Bad username or password.  Use the Back Button."); 
    }

    $ftp->delete(".forward");
    $ftp->delete(".vacation.msg");

    # Solaris uses .PAG and .DIR files.  While Linux only uses a .DB.
    # So we'll delete the appropriate files based on the configuration you entered

    if ($config{'os_type'} eq "solaris") {   
        $ftp->delete(".vacation.pag");
        $ftp->delete(".vacation.dir");
    } else {
        $ftp->delete(".vacation.db");
    }

    $ftp->quit;

    &html_open();
    print "<HR>\n";
    print "<CENTER><TABLE BORDER=1>\n";
    print "<TR $tb ALIGN=center><TD><H3><STRONG>Vacation Message Successfully Changed!</STRONG></H3></TD></TR>\n";
    print "<TR $cb ALIGN=center><TD><H3>Mail vacation service for <STRONG><i>$user</i></STRONG> removed.</H3></TD></TR>\n";
    print "</TABLE></CENTER>\n";

    print "<CENTER><P>Use the link below, or your <b>back</b> function to navigate back to where you were.</P></CENTER>\n";

    &html_close();
}

# To set vacation service connect and create:
#	.vacation.msg	-- the message
#	.vacation.pag	-- data base history
#	.vacation.dir	-- data base history
#	.forward	-- to pipe to user and vacation service.

sub set_vacation {

    $ftp = Net::FTP->new($config{'server_domain'}, Debug => 0); 
    unless ($ftp->login($user, $pass)) {
        $ftp->quit; 
        &html_abort("Cannot log into server!  Bad username or password.  Use the Back Button.");
    }

    # Save and put .vacation.msg (w/o <cr>'s)

    open(OUTPUT,">$tmp") || &html_abort("Cannot save message");
    $mess =~ s/\r//g;	print OUTPUT $mess;
    close(OUTPUT);

    $ftp->put($tmp, ".vacation.msg");


    # Solaris uses .PAG and .DIR files.  While Linux only uses a .DB.
    # and Slackware gives you another .db file
    # So we'll FTP the appropriate files based on the configuration you entered

    if ($config{'os_type'} eq "solaris") {

        # Null .vacation.dir and .vacation.pag

        open(OUTPUT,">$tmp") || &html_abort("Cannot create null file");
        close(OUTPUT);

        $ftp->put($tmp, ".vacation.pag");
        $ftp->put($tmp, ".vacation.dir");

	# This is for Slackware

    } elsif ($config{'os_type'} eq "slackware") {
        
        $ftp->put("vacation.db.slack", ".vacation.db");

    } else {
        $ftp->put("vacation.db", ".vacation.db");
    }


    # Get Aliases for user so that they can be recognized through .forward
    # Aliase name can ONLY be in the format of: Firstname.Lastname

    $aliasename = ""; 
    if ($config{'aliase_path'} ne "") {
        open(ALIASEOUT, "grep -w $user $config{'aliase_path'}/aliases|") || &html_about("Cannot read Aliases file");
        @aliaselist = <ALIASEOUT>;
        close(ALIASEOUT);

        $aindx = 0;
        $aliasename = "";

        while ($aindx < @aliaselist) {
            @name = split(/:/,$aliaselist[$aindx]);
            if ($name[0] =~ /^[A-Za-z\-]+\.[A-Za-z\-]+$/) { 
                $aliasename = "-a $name[0]";
                $aindx = @aliaselist;
            }
            $aindx += 1;
        }
    }

    # Save and put .forward file

    open(OUTPUT,">$tmp") || &html_abort("Cannot save message");
    print OUTPUT "\\$user, \"|$config{'vacation_path'}/vacation $aliasename $user\"";
    close(OUTPUT);

    $ftp->put($tmp, ".forward");
    $ftp->quit;

    # Close it off and report ok
    &html_open();
    print "<HR>\n";
    print "<CENTER><TABLE BORDER=1>\n";
    print "<TR $tb ALIGN=center><TD><H3><STRONG>Vacation Message Successfully Changed!</STRONG></H3></TD></TR>\n";
    print "<TR $cb ALIGN=center><TD><H3>Mailing vacation service installed for: <i>$user</i>.</H3></TD></TR>\n";
    print "</TABLE></CENTER>\n";

    print "<CENTER><P>Use the link below, or your <b>back</b> function to navigate back to where you were.</P></CENTER>\n";
    &html_close();
}

# Gotta be invoked by the right methods

($ENV{'REQUEST_METHOD'} eq 'POST') ||
	&html_abort("Wrong methods for invoking this gateway");

# Always need name and password

&html_abort("No login name provided!")
	unless (defined($user) && $user =~ /./);
&html_abort("No login password provided!")
	unless (defined($pass) && $pass =~ /./);

# May do set vacation or unset (ie. remove).

if ($mode eq 'set') {
	&html_abort("No vacation message provided!")
		unless (defined($mess) && $mess =~ /./);
	&set_vacation();
}

&unset_vacation();




